var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
import { useState } from 'react';
import { IonItem, IonLabel } from '@ionic/react';
export function IonFormItem(props) {
    var renderLabel = props.renderLabel || IonFormItemOptions.Label;
    function onIonChange(e) {
        var _a;
        var value = 'checked' in e.detail ? e.detail.checked : e.detail.value;
        if (props.mapValue) {
            value = props.mapValue(e, props.state[props.name]);
        }
        props.setState(__assign(__assign({}, props.state), (_a = {}, _a[props.name] = value, _a)));
    }
    return (_jsxs(IonItem, { children: [renderLabel(props), props.renderContent({
                name: props.name.toString(),
                onIonChange: onIonChange,
                value: props.state[props.name],
                checked: props.state[props.name],
            })] }, void 0));
}
export var IonFormItemOptions = {
    Label: function Label(props) {
        var label = props.label || props.name.toString();
        return _jsx(IonLabel, { children: label }, void 0);
    },
};
export function useIonFormState(initialValue) {
    if (initialValue === void 0) { initialValue = {}; }
    var _a = useState(initialValue), state = _a[0], setState = _a[1];
    function reset() {
        setState(initialValue);
    }
    return {
        state: state,
        setState: setState,
        reset: reset,
        item: function (props) {
            return _jsx(IonFormItem, __assign({ state: state, setState: setState }, props), void 0);
        },
    };
}
//# sourceMappingURL=use-ion-form-state.js.map